routes/web.php
<?php

use App\Http\Controllers\DashboardController;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\PengumumanController;
use App\Http\Controllers\PermissionController;
use App\Http\Controllers\ProductCategoryController;
use App\Http\Controllers\ProductController;
use App\Http\Controllers\ProfileController;
use App\Http\Controllers\RoleController;
use App\Http\Controllers\SettingController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes();

Route::get('/', function () {
    return redirect()->route('login');
});

Route::middleware(['auth', 'permission'])->group(function () {
    Route::group(['prefix' => 'dashboard', 'as' => 'dashboard.'], function () {
        Route::get('/', [DashboardController::class, 'index'])->name('index');
    });

    Route::group(['prefix' => 'blank', 'as' => 'blank.'], function () {
        Route::get('/', function () {
            return view('sample.blank.index');
        })->name('index');
    });

    Route::group(['prefix' => 'product', 'as' => 'product.'], function () {
        Route::get('/', [ProductController::class, 'index'])->name('index');
        Route::get('/create', [ProductController::class, 'create'])->name('create');
        Route::post('/store', [ProductController::class, 'store'])->name('store');
        Route::get('/edit/{product}', [ProductController::class, 'edit'])->name('edit');
        Route::patch('/update/{product}', [ProductController::class, 'update'])->name('update');
        Route::delete('/destroy/{product}', [ProductController::class, 'destroy'])->name('destroy');
    });

    Route::group(['prefix' => 'product-category', 'as' => 'product-category.'], function () {
        Route::get('/', [ProductCategoryController::class, 'index'])->name('index');
        Route::get('/create', [ProductCategoryController::class, 'create'])->name('create');
        Route::post('/store', [ProductCategoryController::class, 'store'])->name('store');
        Route::get('/edit/{product_category}', [ProductCategoryController::class, 'edit'])->name('edit');
        Route::patch('/update/{product_category}', [ProductCategoryController::class, 'update'])->name('update');
        Route::delete('/destroy/{product_category}', [ProductCategoryController::class, 'destroy'])->name('destroy');
    });
    
    Route::group(['prefix' => 'setting', 'as' => 'setting.'], function () {
        Route::group(['prefix' => 'profile', 'as' => 'profile.'], function () {
            Route::get('/', [ProfileController::class, 'index'])->name('index');
            Route::patch('update', [ProfileController::class, 'update'])->name('update');
        });

        Route::group(['prefix' => 'permission', 'as' => 'permission.'], function () {
            Route::get('/', [PermissionController::class, 'index'])->name('index');
            Route::patch('update/{permission}', [PermissionController::class, 'update'])->name('update');
            Route::post('assign-revoke', [PermissionController::class, 'assignRevoke'])->name('assign_revoke');
            Route::get('refresh', [PermissionController::class, 'refresh'])->name('refresh');
            Route::get('refresh-and-assign', [PermissionController::class, 'refreshAndAssign'])->name('refresh_and_assign');
            Route::delete('destroy/{permission}', [PermissionController::class, 'destroy'])->name('destroy');
        });

        Route::group(['prefix' => 'role', 'as' => 'role.'], function () {
            Route::get('/', [RoleController::class, 'index'])->name('index');
            Route::post('store', [RoleController::class, 'store'])->name('store');
            Route::patch('update/{role}', [RoleController::class, 'update'])->name('update');
            Route::delete('destroy/{role}', [RoleController::class, 'destroy'])->name('destroy');
        });
    });

});

app/Models/Permission.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Spatie\Permission\Models\Permission as SpatiePermission;

class Permission extends SpatiePermission
{
    use HasFactory;

    protected $fillable = [
        'name',
        'guard_name',
        'alias'
    ];
}

app/Http/Controllers/PermissionController.php
<?php

namespace App\Http\Controllers;

use App\DataTables\PermissionDataTable;
use App\Models\Permission;
use Exception;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Log;
use App\Models\Role;
use Illuminate\Support\Facades\Artisan;
use Illuminate\Support\Facades\Route;

class PermissionController extends Controller
{
    public function index(PermissionDataTable $permissionDataTable)
    {
        $include_page = 'setting.permission.datatable';
        $page_title = 'Permission';

        $data = [
            'include_page' => $include_page,
            'page_title' => $page_title,
        ];
        return $permissionDataTable->render('setting.index', $data);
    }

    public function assignRevoke(Request $request)
    {
        try{
            $role = Role::find($request->role_id);
            if($role->hasPermissionTo($request->permission)){
                $role->revokePermissionTo($request->permission);
            }else{
                $role->givePermissionTo($request->permission);
            }
        }catch(Exception $e){
            Log::info($e->getMessage());
            return response(['code' => 0, 'message' => 'Unable to update permission']);
        }
        return response(['code' => 1, 'message' => 'Permission updated']);
    }

    public function refresh()
    {
        try{
            Artisan::call('db:seed --class="PermissionSeeder"');
        }catch(Exception $e){
            Log::info($e->getMessage());
            return redirect()->back()->with('error', 'Unable to refresh permissions');
        }

        return redirect()->back()->with('success', 'Permission refreshed successfully');
    }

    public function refreshAndAssign()
    {
        try{
            Artisan::call('db:seed --class="PermissionSeeder"');
            Artisan::call('db:seed --class="RoleHasPermissionSeeder"');
        }catch(Exception $e){
            Log::info($e->getMessage());
            return redirect()->back()->with('error', 'Unable to refresh and assign permissions');
        }

        return redirect()->back()->with('success', 'Permission refreshed and assigned successfully');
    }

    public function update(Request $request, Permission $permission)
    {
        try{
            $permission->update($request->all());
        }catch(Exception $e){
            Log::info($e->getMessage());
            return response(['code' => 0, 'message' => 'Unable to update permission']);
        }

        return response(['code' => 1, 'message' => 'Permission updated successfully']);
    }

    public function destroy(Permission $permission)
    {
        try{
            if(Route::has($permission->name)){
                return response(['code' => 0, 'message' => 'Route Exists and can not be deleted']);
            }

            $permission->delete();
        }catch(Exception $e){
            Log::info($e->getMessage());
            return response(['code' => 0, 'message' => 'Unable to delete permission']);
        }

        return response(['code' => 1, 'message' => 'Permission deleted successfully']);
    }
}

app/Http/Controllers/SettingController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

class SettingController extends Controller
{
    //
}

resources/views/setting/permission/datatable.blade.php
@push('styles')
    <link rel="stylesheet" type="text/css" href="{{ asset('plugin/datatables/datatables.min.css') }}" />
@endpush

<div class="card">
    <div class="card-header text-right mb-0 pb-0">
        <a href="{{ route('setting.permission.refresh') }}" class="btn btn-primary"><i class="fas fa-sync"></i> Refresh Permission</a>
        <a href="{{ route('setting.permission.refresh_and_assign') }}" class="btn btn-danger"><i class="fas fa-magic"></i> Refresh & Assign All Permission To Admin</a>
    </div>
    
    <div class="card-body">
        {!! $dataTable->table(['width' => '100%']) !!}
    </div>
</div>

<!-- Modal -->
<div class="modal fade" id="permissionModal" tabindex="-1" aria-labelledby="permissionModalLabel" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="permissionModalLabel">Edit Permission</h5>
                <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
            </div>
            <div class="modal-body">
                {!! Form::hidden('id', null, ['id' => 'permissionId']) !!}
                {!! Form::label('permissionAlias', 'Alias', []) !!}
                {!! Form::text('alias', null, ['class' => 'form-control', 'id' => 'permissionAlias']) !!}
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
                <button type="button" id="btnUpdatePermission" onclick="updatePermission(this)" data-url=""
                    class="btn btn-primary">Update</button>
            </div>
        </div>
    </div>
</div>

@push('scripts')
    <script type="text/javascript" src="{{ asset('plugin/datatables/datatables.min.js') }}"></script>
    {!! $dataTable->scripts() !!}

    <script>
        function initCheckbox() {
            const checkBox = document.querySelectorAll('input[type="checkbox"].permission')

            for (let i = 0; i < checkBox.length; i++) {
                const roleName = checkBox[i].getAttribute('data-role-name')
                const roleId = checkBox[i].getAttribute('data-role-id')
                const permission = JSON.parse(checkBox[i].getAttribute('data-permission'))
                if (permission.roles.indexOf(roleName) > -1) {
                    checkBox[i].checked = true
                }

                checkBox[i].addEventListener('click', target => {
                    updateRolePermission(roleId, permission.permission)
                })
            }
        }

        $("#permissionDatatable").on('draw.dt', function() {
            initCheckbox();
        });

        function updateRolePermission(roleId, permission) {
            const url = "{{ route('setting.permission.assign_revoke') }}"
            const formData = new FormData()
            formData.append('role_id', roleId)
            formData.append('permission', permission)

            fetch(url, {
                    headers: {
                        'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content'),
                    },
                    method: 'POST',
                    body: formData,
                })
                .then(response => response.json())
                .then(data => {
                    showToast(data.code, data.message)
                })
                .catch((error) => {
                    showToast(0, 'Something went wrong')
                });
        }

        function showToast(code, text) {
            if (code == 1) {
                toastr.success(text)
            }
            if (code == 0) {
                toastr.error(text)
            }
        }
    </script>

    <script>
        const permissionAlias = document.getElementById('permissionAlias')
        const permissionId = document.getElementById('permissionId')
        const btnUpdatePermission = document.getElementById('btnUpdatePermission')

        function editPermission(permission) {
            const alias = permission.getAttribute('data-alias')
            const id = permission.getAttribute('data-id')
            const url = permission.getAttribute('data-url')

            permissionAlias.value = alias
            permissionId.value = id
            btnUpdatePermission.setAttribute('data-url', url)
        }

        function updatePermission() {
            if (permissionAlias.value == null || permissionAlias.value == undefined || permissionAlias.value == '') {
                return showToast(0, 'Alias could not be empty')
            }

            const url = btnUpdatePermission.getAttribute('data-url') + '?_method=PATCH'
            const formData = new FormData()
            formData.append('permission_id', permissionId.value)
            formData.append('alias', permissionAlias.value)
            formData.append('_method', 'PATCH')

            fetch(url, {
                    headers: {
                        'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content'),
                    },
                    method: 'POST',
                    body: formData,
                })
                .then(response => response.json())
                .then(data => {
                    showToast(data.code, data.message)
                    if (data.code == 1) {
                        $('table').DataTable().ajax.reload()
                        setTimeout(() => {
                            initCheckbox()
                        }, 500);
                    }
                })
                .catch((error) => {
                    showToast(0, 'Something went wrong')
                });
        }
    </script>
@endpush

resources/views/setting/permission/datatables_actions.blade.php
<div class="form-group">
    <a href="#" class="btn btn-warning" data-bs-toggle="modal" data-bs-target="#permissionModal" onclick="editPermission(this)" data-alias="{{ $alias }}" data-id="{{ $id }}" data-url="{{ route('setting.permission.update', $id) }}" data-bs-placement="bottom" title="Edit" ><i class="menu-icon fa fa-pencil-alt"></i></a>
    {{-- <a href="{{ route('setting.permission.edit', $id) }}" class="btn btn-warning" data-bs-toggle="tooltip" data-bs-placement="bottom" title="Edit" ><i class="menu-icon fa fa-pencil-alt"></i></a> --}}
    @if (!Route::has($name))
        <a href="#" onclick="deleteModel('{{ route('setting.permission.destroy', $id) }}', 'permissionDatatable', 'permission', 'all user will unable to access route {{ $name }} again, data could be restored by clicking refresh permission')" class="btn btn-danger" data-bs-toggle="tooltip" data-bs-placement="bottom" title="Hapus"><i class="menu-icon fa fa-trash"></i></a>
    @endif
</div>